Description: fix trusted domain regex
Author: Yadd <yadd@debian.org>
Origin: upstream, https://gitlab.ow2.org/lemonldap-ng/lemonldap-ng/-/commit/3b8222ae8
Bug: https://gitlab.ow2.org/lemonldap-ng/lemonldap-ng/-/issues/2535
Forwarded: not-needed
Last-Update: 2021-06-25

--- a/lemonldap-ng-portal/lib/Lemonldap/NG/Portal/Main/Init.pm
+++ b/lemonldap-ng-portal/lib/Lemonldap/NG/Portal/Main/Init.pm
@@ -391,7 +391,7 @@
             }
         }
 
-        my $tmp = 'https?://' . $re->as_string . '(?::\d+)?(?:/|$)';
+        my $tmp = '^https?://' . $re->as_string . '(?::\d+)?(?:/|$)';
         $self->trustedDomainsRe(qr/$tmp/);
 
     }
--- a/lemonldap-ng-portal/lib/Lemonldap/NG/Portal/Main/Run.pm
+++ b/lemonldap-ng-portal/lib/Lemonldap/NG/Portal/Main/Run.pm
@@ -885,14 +885,14 @@
     my $csp = $self->csp . "form-action " . $self->conf->{cspFormAction};
     if ( my $url = $req->urldc ) {
         $self->logger->debug("Required urldc : $url");
-        $url =~ s#(https?://[^/]+).*#$1#;
+        $url =~ s#^(https?://[^/]+).*#$1#;
         $self->logger->debug("Set CSP form-action with urldc : $url");
         $csp .= " $url";
     }
     my $url = $args{params}->{URL};
     if ( defined $url ) {
         $self->logger->debug("Required Params URL : $url");
-        if ( $url =~ s#(https?://[^/]+).*#$1# ) {
+        if ( $url =~ s#^(https?://[^/]+).*#$1# ) {
             $self->logger->debug("Set CSP form-action with Params URL : $url");
             $csp .= " $url";
         }
@@ -932,7 +932,7 @@
     # Check if frames need to be embedded
     my @url;
     if ( $req->info ) {
-        @url = map { s#https?://([^/]+).*#$1#; $_ }
+        @url = map { s#^https?://([^/]+).*#$1#; $_ }
           ( $req->info =~ /<iframe.*?src="(.*?)"/sg );
     }
     if (@url) {
